package be.iminds.ilabt.jfed.rspec.model.impl;

import be.iminds.ilabt.jfed.rspec.model.GeantTestbedType;
import be.iminds.ilabt.jfed.rspec.model.WebVncService;
import be.iminds.ilabt.jfed.util.common.GeniUrn;

import java.util.ArrayList;
import java.util.List;

/**
 * User: twalcari
 * Date: 5/22/2015
 * Time: 10:38
 */
public class BasicGeantTestbedType implements GeantTestbedType {
    private String name;
    private String dsl;

    private GeniUrn componentManagerId;
    private GeniUrn componentId;
    private GeniUrn sliverId;

    private double editorX;
    private double editorY;

    private BasicVpnService vpnService;
    private final List<WebVncService> webVncServices = new ArrayList<>();

   // private final Map<String, RspecInterfaceBinding> portBindings = new HashMap<String, RspecInterfaceBinding>();

    public BasicGeantTestbedType() {
    }

    public BasicGeantTestbedType(String name) {
        this.name = name;
    }

    public BasicGeantTestbedType(GeantTestbedType gtt) {
        setName(gtt.getName());
        setDsl(gtt.getDsl());
        setComponentManagerId(gtt.getComponentManagerId());
        setComponentId(gtt.getComponentId());
        setSliverId(gtt.getSliverId());

        setEditorX(gtt.getEditorX());
        setEditorY(gtt.getEditorY());

        setVpnService(gtt.getVpnService());
        webVncServices.addAll(gtt.getWebVncServices());
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public void setName(String name) {
        this.name = name;
    }

    @Override
    public String getDsl() {
        return dsl;
    }

    @Override
    public void setDsl(String dsl) {
        this.dsl = dsl;
    }

    @Override
    public GeniUrn getComponentManagerId() {
        return componentManagerId;
    }

    @Override
    public void setComponentManagerId(GeniUrn componentManagerId) {
        this.componentManagerId = componentManagerId;
    }

    @Override
    public GeniUrn getComponentId() {
        return componentId;
    }

    @Override
    public void setComponentId(GeniUrn componentId) {
        this.componentId = componentId;
    }

    @Override
    public GeniUrn getSliverId() {
        return sliverId;
    }

    @Override
    public void setSliverId(GeniUrn sliverId) {
        this.sliverId = sliverId;
    }

    @Override
    public double getEditorX() {
        return editorX;
    }

    @Override
    public void setEditorX(double editorX) {
        this.editorX = editorX;
    }

    @Override
    public double getEditorY() {
        return editorY;
    }

    @Override
    public void setEditorY(double editorY) {
        this.editorY = editorY;
    }

    @Override
    public BasicVpnService getVpnService() {
        return vpnService;
    }

    @Override
    public void setVpnService(VpnService vpnService) {
        this.vpnService = new BasicVpnService(vpnService);
    }

    @Override
    public List<WebVncService> getWebVncServices() {
        return webVncServices;
    }

    @Override
    public void setWebVncServices(List<WebVncService> webVncServices) {
        this.webVncServices.clear();
        this.webVncServices.addAll(webVncServices);
    }

    @Override
    public void addWebVncService(WebVncService webVncService) {
        this.webVncServices.add(webVncService);
    }

    //    @Override
//    public Map<String, RspecInterfaceBinding> getPortBindings() {
//        return portBindings;
//    }
//
//    @Override
//    public void setPortBindings(Map<String, RspecInterfaceBinding> portBindings) {
//        this.portBindings.keySet().retainAll(portBindings.keySet());
//        this.portBindings.putAll(portBindings);
//    }

    public static class BasicVpnService implements GeantTestbedType.VpnService {
        private String endpoint;
        private String username;
        private String password;

        public BasicVpnService(String endpoint, String username, String password) {
            this.endpoint = endpoint;
            this.username = username;
            this.password = password;
        }
        public BasicVpnService(VpnService vpnService) {
            this.endpoint = vpnService.getEndpoint();
            this.username = vpnService.getUsername();
            this.password = vpnService.getPassword();
        }

        @Override
        public String getEndpoint() {
            return endpoint;
        }

        @Override
        public String getUsername() {
            return username;
        }

        @Override
        public String getPassword() {
            return password;
        }
    }

}
